/*	Util.h
*
*	Useful utilities.
*
*	Written by Cathy & Tom Saxton
*	robotics@idleloop.com
*/

#pragma once

typedef unsigned char uchar;
typedef unsigned int uint;
typedef unsigned long ulong;
typedef unsigned short ushort;

enum
{
	fFalse = 0,
	fTrue = 1
};

#define DIM(a) (sizeof(a) / sizeof(a[0]))

/* note: only use macros if the args are simple expressions (otherwise
   they may be evaluated twice) */
#define Abs(x) (((x) < 0) ? (-(x)) : (x))
#define Min(x, y) (((x) < (y)) ? (x) : (y))
#define Max(x, y) (((x) > (y)) ? (x) : (y))

inline short AbsW(short x) { return x < 0 ? -x : x; }
inline short MinW(short x, short y) { return x < y ? x : y; }
inline short MaxW(short x, short y) { return x > y ? x : y; }
inline long AbsLw(long x) { return x < 0 ? -x : x; }
inline long MinLw(long x, long y) { return x < y ? x : y; }
inline long MaxLw(long x, long y) { return x > y ? x : y; }

/* macros to set and clear bits in registers */
#define SetBit(sfr, bit) ((sfr) |= (1 << (bit)))
#define ClearBit(sfr, bit) ((sfr) &= ~(1 << (bit)))

